package com.test;

import com.test.entities.Person;
import com.test.service.PersonFacade;

import com.vaadin.annotations.Theme;
import com.vaadin.cdi.CDIUI;
import com.vaadin.server.VaadinRequest;
import com.vaadin.ui.Table;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;
import javax.ejb.EJB;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import org.vaadin.addons.lazyquerycontainer.LazyEntityContainer;

@Theme("mytheme")
@SuppressWarnings("serial")
@CDIUI
public class MyVaadinUI extends UI
{

    @EJB
    private PersonFacade personFacade;
    
    @Override
    protected void init(VaadinRequest request) {
        final VerticalLayout layout = new VerticalLayout();
        layout.setMargin(true);
        setContent(layout);
        
        layout.setWidth(300, Unit.PIXELS);
        layout.setHeight(100, Unit.PERCENTAGE);
        
        for(int i = 0; i < 10; i++) {
            Person person = new Person();
            person.setFirstName("" + i);
            personFacade.create(person);
        }
        
        
        EntityManagerFactory entFactory = Persistence.createEntityManagerFactory("com.company_ContainerTest_war_1.0-SNAPSHOTPU");
        EntityManager manager = entFactory.createEntityManager();
        
        LazyEntityContainer container = new LazyEntityContainer(manager, Person.class, 200, "id", false, true, true);
        
        container.addContainerProperty("firstName", String.class, "", true, true);
        container.addContainerProperty("account.loginName", String.class, "", true, true);
        
        Table table = new Table("Test", container);
        table.setSortEnabled(true);
        table.setSizeFull();
        layout.addComponent(table);
    }

}
